diff --git a/coders/png.c b/coders/png.c
index 8c8f0c69fa..dfe6843ac1 100644
--- a/coders/png.c
+++ b/coders/png.c
@@ -4384,7 +4384,8 @@ static Image *ReadOneJNGImage(MngInfo *mng_info,
 
     if (length != 0)
       {
-        chunk=(unsigned char *) AcquireQuantumMemory(length,sizeof(*chunk));
+        chunk=(unsigned char *) AcquireQuantumMemory(length+MagickPathExtent,
+          sizeof(*chunk));
 
         if (chunk == (unsigned char *) NULL)
           ThrowReaderException(ResourceLimitError,"MemoryAllocationFailed");
@@ -5259,8 +5260,8 @@ static Image *ReadOneMNGImage(MngInfo* mng_info, const ImageInfo *image_info,
 
         if (length != 0)
           {
-            chunk=(unsigned char *) AcquireQuantumMemory(length,
-             sizeof(*chunk));
+            chunk=(unsigned char *) AcquireQuantumMemory(length_
+             MagickPathExtent,sizeof(*chunk));
 
             if (chunk == (unsigned char *) NULL)
               ThrowReaderException(ResourceLimitError,
